package name.pehl.totoe.xml.client.internal;

import name.pehl.totoe.xml.client.Document;
import name.pehl.totoe.xml.client.XmlParseException;

import com.google.gwt.core.client.JavaScriptException;
import com.google.gwt.core.client.JavaScriptObject;

/**
 * @author $Author: harald.pehl $
 * @version $Date: 2010-10-26 14:04:16 +0200 (Di, 26 Okt 2010) $ $Revision: 629
 *          $
 */
public class XmlParserImpl
{
    // ------------------------------------------------------------------- JSNI

    private static final JavaScriptObject nativeParser = XmlParserImpl.initialize();


    private static native JavaScriptObject initialize() /*-{
        return new $wnd.DOMParser();
    }-*/;


    // ---------------------------------------------------------- parse methods

    public Document parse(String xml, String namespaces)
    {
        if (xml == null || xml.trim().length() == 0)
        {
            return null;
        }
        try
        {
            JavaScriptObject documentJso = parseImpl(xml, namespaces);
            return NodeFactory.create(documentJso);
        }
        catch (JavaScriptException e)
        {
            throw new XmlParseException(e.getMessage(), e);
        }
    }


    private native JavaScriptObject parseImpl(String xml, String namespaces) /*-{
        var domDoc = @name.pehl.totoe.xml.client.internal.XmlParserImpl::nativeParser.parseFromString(xml, "text/xml");
        var error = $wnd.Sarissa.getParseErrorText(domDoc);
        if (error != $wnd.Sarissa.PARSED_OK) 
        {
            if (error == $wnd.Sarissa.PARSED_EMPTY) 
            {
                return null;
            }
            else if (error == $wnd.Sarissa.PARSED_UNKNOWN_ERROR) 
            {
                throw (new Error("Unkown error parsing xml file."));
            }
            else 
            {
                throw (new Error(error));
            }
            return null;
        }

        if (namespaces != null)
        {
            try
            {
                $wnd.Sarissa.setXpathNamespaces(domDoc, namespaces);
            }
            catch (e)
            {
                throw (new Error(e));
            }
        }
        return domDoc;
    }-*/;
}
